https://github.com/python-greenlet/greenlet/pull/160

From 839dfa8d4bc4e9a0b97a1984ab2519841f5511e4 Mon Sep 17 00:00:00 2001
From: Matt Turner <mattst88@gmail.com>
Date: Mon, 16 Mar 2020 14:38:21 -0700
Subject: [PATCH] Add support for DEC Alpha

---
 platform/switch_alpha_unix.h | 30 ++++++++++++++++++++++++++++++
 slp_platformselect.h         |  2 ++
 2 files changed, 32 insertions(+)
 create mode 100644 platform/switch_alpha_unix.h

diff --git a/platform/switch_alpha_unix.h b/platform/switch_alpha_unix.h
new file mode 100644
index 0000000..216619f
--- /dev/null
+++ b/platform/switch_alpha_unix.h
@@ -0,0 +1,30 @@
+#define STACK_REFPLUS 1
+
+#ifdef SLP_EVAL
+#define STACK_MAGIC 0
+
+#define REGS_TO_SAVE "$9", "$10", "$11", "$12", "$13", "$14", "$15", \
+		     "$f2", "$f3", "$f4", "$f5", "$f6", "$f7", "$f8", "$f9"
+
+static int
+slp_switch(void)
+{
+  register int ret;
+  register long *stackref, stsizediff;
+  __asm__ volatile ("" : : : REGS_TO_SAVE);
+  __asm__ volatile ("mov $30, %0" : "=r" (stackref) : );
+  {
+      SLP_SAVE_STATE(stackref, stsizediff);
+      __asm__ volatile (
+	  "addq $30, %0, $30\n\t"
+	  : /* no outputs */
+	  : "r" (stsizediff)
+	  );
+      SLP_RESTORE_STATE();
+  }
+  __asm__ volatile ("" : : : REGS_TO_SAVE);
+  __asm__ volatile ("mov $31, %0" : "=r" (ret) : );
+  return ret;
+}
+
+#endif
diff --git a/slp_platformselect.h b/slp_platformselect.h
index bed9e6d..fb99aed 100644
--- a/slp_platformselect.h
+++ b/slp_platformselect.h
@@ -51,4 +51,6 @@
 #include "platform/switch_csky_gcc.h" /* gcc on csky */
 #elif defined(__GNUC__) && defined(__riscv)
 #include "platform/switch_riscv_unix.h" /* gcc on RISC-V */
+#elif defined(__GNUC__) && defined(__alpha__)
+#include "platform/switch_alpha_unix.h" /* gcc on DEC Alpha */
 #endif
-- 
2.24.1

